--- ./JP0429B.ICS.org	2000-10-30 14:58:12.000000000 +0900
+++ ./JP0429B.ICS	2011-12-03 19:51:36.000000000 +0900
@@ -13,7 +13,7 @@
 END:VTIMEZONE
 BEGIN:VEVENT
 UID:20001030144607@earmath.siki.org
-DTSTAMP:20001030T144607
+DTSTAMP:20111203T195130
 SUMMARY:みどりの日
 LOCATION:日本
 DESCRIPTION:Greenery Day\n
@@ -25,8 +25,10 @@
 DTSTART;TZID=Japan:19890429T000000
 DTEND;TZID=Japan:19890430T000000
 RRULE:FREQ=YEARLY;INTERVAL=1;BYMONTH=4;BYMONTHDAY=29
+ ;UNTIL=20061231T000000Z
 CATEGORIES:祝日
 TRANSP:TRANSPARENT
+SEQUENCE:1
 PRIORITY:0
 RELATED-TO;RELTYPE=PARENT:<20001030144606@earmath.siki.org>
 CLASS:PUBLIC
--- ./JP0429C.ICS.org	2011-12-03 19:43:57.000000000 +0900
+++ ./JP0429C.ICS	2011-12-03 20:01:13.000000000 +0900
@@ -0,0 +1,32 @@
+BEGIN:VCALENDAR
+PRODID:-//NOMURA Mahito//Manually//EN
+METHOD:PUBLISH
+VERSION:2.0
+BEGIN:VTIMEZONE
+TZID:Japan
+BEGIN:STANDARD
+DTSTART:19390101T000000
+TZOFFSETFROM:+0900
+TZOFFSETTO:+0900
+TZNAME:JST
+END:STANDARD
+END:VTIMEZONE
+BEGIN:VEVENT
+UID:20111203200000@earmath.siki.org
+DTSTAMP:20111203T200100
+SUMMARY:昭和の日
+LOCATION:日本
+DESCRIPTION:Greenery Day\n
+ 激動の日々を経て、復興を遂げた昭和の時代を顧み、
+ 国の将来に思いをいたす。\n\n
+ ・平成17年「国民の祝日に関する法律の一部を改正する法律」
+ 平成19年1月1日公布で「みどりの日」から改正
+DTSTART;TZID=Japan:20070429T000000
+DTEND;TZID=Japan:20070430T000000
+RRULE:FREQ=YEARLY;INTERVAL=1;BYMONTH=4;BYMONTHDAY=29
+CATEGORIES:祝日
+TRANSP:TRANSPARENT
+PRIORITY:0
+CLASS:PUBLIC
+END:VEVENT
+END:VCALENDAR
\ No newline at end of file
--- ./JP0504.ICS.org	2001-04-08 15:46:22.000000000 +0900
+++ ./JP0504.ICS	2011-12-03 19:56:27.000000000 +0900
@@ -12,16 +12,64 @@
 END:STANDARD
 END:VTIMEZONE
 BEGIN:VEVENT
-UID:20001030144609@earmath.siki.org
-DTSTAMP:20001030T144609
+DTSTAMP:20111203T195630
 SUMMARY:国民の休日
 LOCATION:日本
 DESCRIPTION:Holiday for a Nation\n\n
  ・昭和60年法律103号「国民の祝日に関する
  法律の一部を改正する法律」昭和60年12月27日公布
-DTSTART;TZID=Japan:19860504T000000
-DTEND;TZID=Japan:19860505T000000
+DTSTART;TZID=Japan:19880504T000000
+DTEND;TZID=Japan:19880505T000000
 RRULE:FREQ=YEARLY;INTERVAL=1;BYMONTH=5;BYMONTHDAY=4
+ ;UNTIL=19911231T000000Z
+CATEGORIES:祝日
+TRANSP:TRANSPARENT
+PRIORITY:0
+CLASS:PUBLIC
+END:VEVENT
+BEGIN:VEVENT
+DTSTAMP:20111203T195630
+SUMMARY:国民の休日
+LOCATION:日本
+DESCRIPTION:Holiday for a Nation\n\n
+ ・昭和60年法律103号「国民の祝日に関する
+ 法律の一部を改正する法律」昭和60年12月27日公布
+DTSTART;TZID=Japan:19930504T000000
+DTEND;TZID=Japan:19930505T000000
+RRULE:FREQ=YEARLY;INTERVAL=1;BYMONTH=5;BYMONTHDAY=4
+ ;UNTIL=19961231T000000Z
+CATEGORIES:祝日
+TRANSP:TRANSPARENT
+PRIORITY:0
+CLASS:PUBLIC
+END:VEVENT
+BEGIN:VEVENT
+DTSTAMP:20111203T195630
+SUMMARY:国民の休日
+LOCATION:日本
+DESCRIPTION:Holiday for a Nation\n\n
+ ・昭和60年法律103号「国民の祝日に関する
+ 法律の一部を改正する法律」昭和60年12月27日公布
+DTSTART;TZID=Japan:19990504T000000
+DTEND;TZID=Japan:19990505T000000
+RRULE:FREQ=YEARLY;INTERVAL=1;BYMONTH=5;BYMONTHDAY=4
+ ;UNTIL=20021231T000000Z
+CATEGORIES:祝日
+TRANSP:TRANSPARENT
+PRIORITY:0
+CLASS:PUBLIC
+END:VEVENT
+BEGIN:VEVENT
+DTSTAMP:20111203T195630
+SUMMARY:国民の休日
+LOCATION:日本
+DESCRIPTION:Holiday for a Nation\n\n
+ ・昭和60年法律103号「国民の祝日に関する
+ 法律の一部を改正する法律」昭和60年12月27日公布
+DTSTART;TZID=Japan:20040504T000000
+DTEND;TZID=Japan:20040505T000000
+RRULE:FREQ=YEARLY;INTERVAL=1;BYMONTH=5;BYMONTHDAY=4
+ ;UNTIL=20061231T000000Z
 CATEGORIES:祝日
 TRANSP:TRANSPARENT
 PRIORITY:0
--- ./JP0504B.ICS.org	2011-12-03 19:43:57.000000000 +0900
+++ ./JP0504B.ICS	2011-12-03 20:01:32.000000000 +0900
@@ -0,0 +1,32 @@
+BEGIN:VCALENDAR
+PRODID:-//NOMURA Mahito//Manually//EN
+METHOD:PUBLISH
+VERSION:2.0
+BEGIN:VTIMEZONE
+TZID:Japan
+BEGIN:STANDARD
+DTSTART:19390101T000000
+TZOFFSETFROM:+0900
+TZOFFSETTO:+0900
+TZNAME:JST
+END:STANDARD
+END:VTIMEZONE
+BEGIN:VEVENT
+UID:20111203200100@earmath.siki.org
+DTSTAMP:20111203T200200
+SUMMARY:みどりの日
+LOCATION:日本
+DESCRIPTION:Greenery Day\n
+ 自然に親しむとともにその恩恵に感謝し、豊かな
+ 心をはぐくむ。\n\n
+ ・平成17年「国民の祝日に関する法律の一部を改正する法律」
+ 平成19年1月1日公布で4月29日から改正
+DTSTART;TZID=Japan:20070504T000000
+DTEND;TZID=Japan:20070505T000000
+RRULE:FREQ=YEARLY;INTERVAL=1;BYMONTH=5;BYMONTHDAY=4
+CATEGORIES:祝日
+TRANSP:TRANSPARENT
+PRIORITY:0
+CLASS:PUBLIC
+END:VEVENT
+END:VCALENDAR
\ No newline at end of file
--- ./JP0921.ICS.org	2011-12-04 12:27:01.000000000 +0900
+++ ./JP0921.ICS	2011-12-04 12:36:03.000000000 +0900
@@ -0,0 +1,42 @@
+BEGIN:VCALENDAR
+PRODID:-//Taiji Yamada <taiji@aihara.co.jp>//tsv2ics//EN
+METHOD:PUBLISH
+VERSION:2.0
+BEGIN:VTIMEZONE
+TZID:Japan
+BEGIN:STANDARD
+DTSTART:19390101T000000
+TZOFFSETFROM:+0900
+TZOFFSETTO:+0900
+TZNAME:JST
+END:STANDARD
+END:VTIMEZONE
+BEGIN:VEVENT
+DTSTAMP:20111203T212024
+SUMMARY:国民の休日
+LOCATION:日本
+DESCRIPTION:Holiday for a Nation\n\n
+ ・昭和60年法律103号「国民の祝日に関する
+ 法律の一部を改正する法律」昭和60年12月27日公布
+DTSTART;TZID=Japan:20320921T000000
+DTEND;TZID=Japan:20320922T000000
+CATEGORIES:祝日
+TRANSP:TRANSPARENT
+PRIORITY:0
+CLASS:PUBLIC
+END:VEVENT
+BEGIN:VEVENT
+DTSTAMP:20111203T212024
+SUMMARY:国民の休日
+LOCATION:日本
+DESCRIPTION:Holiday for a Nation\n\n
+ ・昭和60年法律103号「国民の祝日に関する
+ 法律の一部を改正する法律」昭和60年12月27日公布
+DTSTART;TZID=Japan:20490921T000000
+DTEND;TZID=Japan:20490922T000000
+CATEGORIES:祝日
+TRANSP:TRANSPARENT
+PRIORITY:0
+CLASS:PUBLIC
+END:VEVENT
+END:VCALENDAR
--- ./JP0922.ICS.org	2011-12-04 12:27:03.000000000 +0900
+++ ./JP0922.ICS	2011-12-04 12:35:54.000000000 +0900
@@ -0,0 +1,84 @@
+BEGIN:VCALENDAR
+PRODID:-//Taiji Yamada <taiji@aihara.co.jp>//tsv2ics//EN
+METHOD:PUBLISH
+VERSION:2.0
+BEGIN:VTIMEZONE
+TZID:Japan
+BEGIN:STANDARD
+DTSTART:19390101T000000
+TZOFFSETFROM:+0900
+TZOFFSETTO:+0900
+TZNAME:JST
+END:STANDARD
+END:VTIMEZONE
+BEGIN:VEVENT
+DTSTAMP:20111203T212024
+SUMMARY:国民の休日
+LOCATION:日本
+DESCRIPTION:Holiday for a Nation\n\n
+ ・昭和60年法律103号「国民の祝日に関する
+ 法律の一部を改正する法律」昭和60年12月27日公布
+DTSTART;TZID=Japan:20090922T000000
+DTEND;TZID=Japan:20090923T000000
+CATEGORIES:祝日
+TRANSP:TRANSPARENT
+PRIORITY:0
+CLASS:PUBLIC
+END:VEVENT
+BEGIN:VEVENT
+DTSTAMP:20111203T212024
+SUMMARY:国民の休日
+LOCATION:日本
+DESCRIPTION:Holiday for a Nation\n\n
+ ・昭和60年法律103号「国民の祝日に関する
+ 法律の一部を改正する法律」昭和60年12月27日公布
+DTSTART;TZID=Japan:20150922T000000
+DTEND;TZID=Japan:20150923T000000
+CATEGORIES:祝日
+TRANSP:TRANSPARENT
+PRIORITY:0
+CLASS:PUBLIC
+END:VEVENT
+BEGIN:VEVENT
+DTSTAMP:20111203T212024
+SUMMARY:国民の休日
+LOCATION:日本
+DESCRIPTION:Holiday for a Nation\n\n
+ ・昭和60年法律103号「国民の祝日に関する
+ 法律の一部を改正する法律」昭和60年12月27日公布
+DTSTART;TZID=Japan:20260922T000000
+DTEND;TZID=Japan:20260923T000000
+CATEGORIES:祝日
+TRANSP:TRANSPARENT
+PRIORITY:0
+CLASS:PUBLIC
+END:VEVENT
+BEGIN:VEVENT
+DTSTAMP:20111203T212024
+SUMMARY:国民の休日
+LOCATION:日本
+DESCRIPTION:Holiday for a Nation\n\n
+ ・昭和60年法律103号「国民の祝日に関する
+ 法律の一部を改正する法律」昭和60年12月27日公布
+DTSTART;TZID=Japan:20370922T000000
+DTEND;TZID=Japan:20370923T000000
+CATEGORIES:祝日
+TRANSP:TRANSPARENT
+PRIORITY:0
+CLASS:PUBLIC
+END:VEVENT
+BEGIN:VEVENT
+DTSTAMP:20111203T212024
+SUMMARY:国民の休日
+LOCATION:日本
+DESCRIPTION:Holiday for a Nation\n\n
+ ・昭和60年法律103号「国民の祝日に関する
+ 法律の一部を改正する法律」昭和60年12月27日公布
+DTSTART;TZID=Japan:20430922T000000
+DTEND;TZID=Japan:20430923T000000
+CATEGORIES:祝日
+TRANSP:TRANSPARENT
+PRIORITY:0
+CLASS:PUBLIC
+END:VEVENT
+END:VCALENDAR